function [ffn,endn] = PrepGenReg(q,k)

% Preparation of input for generation of regressors (this is just some combinatorics)
endn = [];
ffn = [];
% higher values of q
if q > 2
    t = 0;
    endn = zeros(q,1);
    num = (q-2)*k;
    ffn = zeros(num,1);
    for r = 3:q
        endn(r) = nchoosek(r-1+k,k)-1-k; % different terms up to the (r-1)th power 
        for j = 1:k
            t = t + 1; 
            ffn(t) = nchoosek(r-1+k-j,r-1);
        end;
    end;
end;